/**
 *	true = это индекс игрока.
 */
stock bool SF_IsClient(int index)
{
	return index > 0 && index <= MaxClients;
}

/////

/**
 *	Получить координаты места, куда направлен прицел игрока.
 */		
stock bool SF_GetClientAimPosition(int client, float aim_position[3])
{
	float vec[3];
	if (GetClientEyeAngles(client, vec))
	{
		float pos[3];
		GetClientEyePosition(client, pos);
		
		TR_TraceRayFilter(pos, vec, /* flags */MASK_SOLID, RayType_Infinite, OnTraceEntityFilter, /* data */client);
		
		if (TR_DidHit())
		{
			TR_GetEndPosition(aim_position);
			return true;
		}
	}
	return false;
}

static bool OnTraceEntityFilter(int entity, int contentsMask, any data)
{
	//	Игнорируем столкновения с самим собой и оружием.
	
	bool allow_hit = (entity != data);
	
	if ( allow_hit && entity > MaxClients)
	{
		char classname[8];
		if (!GetEntityClassname(entity, SZF(classname)) || strncmp(classname, "weapon_", 7) == 0) {
			allow_hit = false;
		}
	}
	
	return allow_hit;
}

/////

/**
 *	Получить индекс бота.
 *
 *	@param team			0 = любая команда, 1 = spec, 2 = t, 3 = ct.
 *	@param alive		0 = должен быть мертв, 1 = должен быть жив, другое число = любое состояние.
 *	@return				Индекс бота. 0 = не найден.
 */
stock int SF_GetBot(int team=0, int alive=-1)
{
	for (int i = 1; i <= MaxClients; i++) {
		if (IsClientInGame(i) && IsFakeClient(i) && (!team || team == GetClientTeam(i))) {
			switch (alive) {
				case 0: {
					if (!IsPlayerAlive(i)) {
						return i;
					}
				}
				case 1: {
					if ( IsPlayerAlive(i)) {
						return i;
					}
				}
				default: {
					return i;
				}
			}
		}
	}
	return 0;
}